## ocamlnet 3.7.3

=== Makefile ===
# make all: compiles the configured packages with ocamlc
# make opt: compiles the configured packages with ocamlopt
# make install: installs the configured packages
# make clean: cleans everything up

# Inclusion of Makefile.conf may fail when cleaning up:
-include Makefile.conf

NAME=ocamlnet
TOP_DIR=.

# PKGLIST: should be set in Makefile.conf. It contains the packages to
# compile and to install. The following assignment sets it to its 
# default value if no Makefile.conf exists.
PKGLIST ?= netstring cgi

.PHONY: all
all:
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		( cd src/$$pkg && $(MAKE) all ) || exit; \
	done

.PHONY: opt
opt:
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		( cd src/$$pkg && $(MAKE) opt ) || exit; \
	done


.PHONY: doc
doc:
	for pkg in src/*/.; do \
	    test ! -f $$pkg/Makefile -o -f $$pkg/doc-ignore || \
		{ ( cd $$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		  ( cd $$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		  ( cd $$pkg && $(MAKE) ocamldoc.dump ) || exit; \
		}; \
	done
	cd doc; $(MAKE) doc


# The following PHONY rule is important for Cygwin:
.PHONY: install
install:
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre install ) || exit; \
	done

.PHONY: uninstall
uninstall:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre uninstall); \
	done

.PHONY: clean
clean:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre clean); \
	done
	if test -f doc/Makefile; then cd doc && $(MAKE) clean; fi

.PHONY: clean-doc
clean-doc:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile -o -f $$pkg/doc-ignore || \
			( cd $$pkg && $(MAKE) -f Makefile.pre clean-doc); \
	done
	cd doc && $(MAKE) clean-doc

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean:
	rm -f Makefile.conf 
	rm -rf tmp
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre distclean); \
	done

=== examples/camlbox/Makefile ===
all: speed manymult unimult

clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.cmxa *.o *.a speed manymult unimult

speed: speed.ml
	ocamlfind ocamlopt -o speed -package netcamlbox -linkpkg -g speed.ml

manymult: manymult.ml
	ocamlfind ocamlopt -o manymult -package netcamlbox -linkpkg -g manymult.ml

unimult: unimult.ml
	ocamlfind ocamlopt -o unimult -package netcamlbox -linkpkg -g unimult.ml

=== examples/netplex/Makefile ===
TOP_DIR = ../..
include $(TOP_DIR)/Makefile.rules
include $(TOP_DIR)/Makefile.xrules

XDRFILES = operation.x

RPCGEN_AUX_OPTIONS    = -int int32 -hyper int64
RPCGEN_CLIENT_OPTIONS = -int int32 -hyper int64
RPCGEN_SERVER_OPTIONS = -int int32 -hyper int64

CLEAN_LIST += *.astamp *.cstamp *.s2stamp
CLEAN_LIST += $(XDRFILES:.x=_aux.ml) $(XDRFILES:.x=_aux.mli)
CLEAN_LIST += $(XDRFILES:.x=_clnt.ml) $(XDRFILES:.x=_clnt.mli)
CLEAN_LIST += $(XDRFILES:.x=_srv.ml) $(XDRFILES:.x=_srv.mli)
CLEAN_LIST += test_client helper_container

all:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile.code all

opt:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile.code opt

gen: $(XDRFILES:.x=.astamp) $(XDRFILES:.x=.cstamp) $(XDRFILES:.x=.s2stamp)

=== examples/pop/Makefile ===
.PHONY: all

APPS=mbox_list

all: $(APPS)

mbox_list: mbox_list.ml
	ocamlfind ocamlc -g -o $@ -package unix -package netstring -package pop -linkpkg $<

.PHONY: clean
clean:
	rm -f $(APPS) *.cmi *.cmo

=== src/equeue-gtk1/Makefile ===
TOP_DIR=../..

include ./Makefile.gtk
# Sets GTK_PKG, GTK_VERSION, ARCHIVE, FL_NAME

PKGNAME = $(FL_NAME)
OBJECTS = uq_gtk_helper.cmo uq_gtk.cmo
DOBJECTS = uq_gtk.mli

INCLUDES += $(INC_EQUEUE)
INCLUDES += $(INC_NETSYS)

OCAMLC_OPTIONS_FOR_uq_gtk.ml = -syntax camlp4o -package camlp4.macro $(GTK_DEFINES)
OCAMLOPT_OPTIONS_FOR_uq_gtk.ml = -syntax camlp4o -package camlp4.macro $(GTK_DEFINES)

NODEP = @true

include $(TOP_DIR)/Makefile.rules

REQUIRES += $(GTK_PKG)
GTK_DEFINES += -ppopt -D$(GTK_VERSION)

# Manual deps so we don't need ocamldep:
uq_gtk.cmo: uq_gtk_helper.cmo
uq_gtk.cmo: uq_gtk.cmi
uq_gtk.cmx: uq_gtk_helper.cmx
uq_gtk.cmx: uq_gtk.cmi

=== src/equeue-ssl/Makefile ===
TOP_DIR=../..

PKGNAME  = equeue-ssl
ARCHIVE  = equeue_ssl
OBJECTS  = ssl_exts.cmo uq_ssl.cmo https_client.cmo
DOBJECTS = uq_ssl.mli https_client.mli
COBJECTS = ssl_exts_stubs.o

INCLUDES += $(INC_EQUEUE) $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

REQUIRES += unix ssl

include depend

=== src/equeue-tcl/Makefile ===
TOP_DIR=../..

PKGNAME  = equeue-tcl
ARCHIVE  = equeue_tcl
OBJECTS  = uq_tcl.cmo
DOBJECTS = uq_tcl.mli
COBJECTS = tclqueue.o

LINK_OPTIONS = $(EQUEUE_TCL_LIBS)
CC_OPTIONS = $(EQUEUE_TCL_DEFS)

INCLUDES += $(INC_EQUEUE)
INCLUDES += $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/equeue/Makefile ===
TOP_DIR=../..

PKGNAME = equeue
OBJECTS = equeue.cmo unixqueue_util.cmo unixqueue_pollset.cmo \
          unixqueue_select.cmo unixqueue.cmo \
	  uq_resolver.cmo \
          uq_engines.cmo uq_socks5.cmo uq_io.cmo uq_lwt.cmo \
	  uq_libevent.cmo uq_mt.cmo
DOBJECTS = equeue.mli unixqueue.mli unixqueue_pollset.mli \
           unixqueue_select.mli \
	   uq_resolver.mli \
           uq_engines.mli uq_socks5.mli uq_io.mli uq_lwt.mli \
	   uq_libevent.mli uq_mt.mli \
           equeue_intro.txt equeue_howto.txt

INCLUDES += $(INC_NETSYS)
INCLUDES += $(INC_NETSTRING)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netclient/Makefile ===
TOP_DIR=../..

PKGNAME = netclient
OBJECTS =  http_client_conncache.cmo http_client.cmo telnet_client.cmo \
	   ftp_data_endpoint.cmo ftp_client.cmo \
	   http_fs.cmo ftp_fs.cmo
DOBJECTS = http_client_conncache.mli http_client.mli telnet_client.mli \
	   ftp_data_endpoint.mli ftp_client.mli \
	   http_fs.mli ftp_fs.mli \
           netclient_tut.txt

INCLUDES = $(INC_EQUEUE) $(INC_NETSTRING) $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netgssapi/Makefile ===
TOP_DIR=../..

PKGNAME = netgssapi
OBJECTS = netgssapi.cmo
DOBJECTS = netgssapi.mli

INCLUDES += $(INC_NETSYS) $(INC_NETSTRING)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/nethttpd-for-netcgi2/Makefile ===
TOP_DIR=../..

PKGNAME  = nethttpd-for-netcgi2
OBJECTS  = 
DOBJECTS = 
DEP_FILES =

# prevent that anything is created:
ALL =
OPT =

include $(TOP_DIR)/Makefile.rules

=== src/nethttpd/Makefile ===
TOP_DIR=../..

PKGNAME  = nethttpd
OBJECTS  = nethttpd_types.cmo nethttpd_util.cmo \
           nethttpd_kernel.cmo nethttpd_reactor.cmo \
	  nethttpd_engine.cmo nethttpd_services.cmo nethttpd_plex.cmo

DOBJECTS = nethttpd_types.mli nethttpd_kernel.mli nethttpd_reactor.mli \
	   nethttpd_engine.mli nethttpd_services.mli nethttpd_plex.mli \
	   nethttpd_util.mli nethttpd_intro.txt

INCLUDES += $(INC_EQUEUE) $(INC_NETSTRING) $(INC_NETCGI2) $(INC_NETPLEX) \
            $(INC_NETSYS)
PP_OPTIONS = -package "camlp4, camlp4.macro" -syntax "camlp4o"

#PP_OPTIONS_FINDLIB += -ppopt "-DTesting"
# do this to enable test coverage calculations

include $(TOP_DIR)/Makefile.rules

include depend

=== debian/changelog ===
ocamlnet (3.7.3-3build2) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 21:53:27 +0000

ocamlnet (3.7.3-3) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2013 21:17:34 +0100

ocamlnet (3.7.3-2) experimental; urgency=low

  * Cope with netcamlbox and netmulticore not being available on kfreebsd,
    because of lack of named semaphores (fix FTBFS)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Nov 2013 15:33:57 +0100

ocamlnet (3.7.3-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 09 Nov 2013 12:30:24 +0100

ocamlnet (3.6.6-2) experimental; urgency=low

  * New upstream release
  * Compile with OCaml >= 4

 -- Stéphane Glondu <glondu@debian.org>  Thu, 25 Jul 2013 21:22:24 +0200

ocamlnet (3.6.5-1) experimental; urgency=low

  * New upstream release
    - enable netmech-scram and netzip modules
    - Netstring_pcre has moved to its own findlib package (netstring-pcre)
    - remove patches that were merged upstream:
      + Add-rpath-to-Apache-module,
      + Link-against-the-PIC-version-of-libcamlrun
      + Set-FD_CLOEXEC-correctly-using-F_SETFD-not
      + Fix-compilation-with-Apache-2.4
  * Rename libapache2-mod-ocamlnet package and configuration file to
    follow Apache module naming conventions
  * Update copyright file and use format version 1.0
  * Bump Standards-Version to 3.9.4

 -- Stéphane Glondu <glondu@debian.org>  Thu, 06 Jun 2013 11:55:15 +0200

=== debian/control ===
Source: ocamlnet
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-ocaml (>= 0.9),
 dh-apache2,
 ocaml-nox (>= 4),
 camlp4,
 ocaml-findlib (>= 1.4),
 libfindlib-ocaml-dev,
 libpcre-ocaml-dev (>= 6.0.1-2~),
 liblablgtk2-ocaml-dev (>= 2.12.0-4~),
 libcryptgps-ocaml-dev (>= 0.2.1-7~),
 libssl-ocaml-dev (>= 0.4.3-3~),
 libzip-ocaml-dev,
 libcryptokit-ocaml-dev,
 apache2-dev
Standards-Version: 3.9.4
Homepage: http://projects.camlcity.org/projects/ocamlnet.html
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocamlnet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocamlnet.git

Package: libocamlnet-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libocamlnet-ocaml-doc,
 libnethttpd-ocaml-dev
Provides:
 libequeue-ocaml-dev,
 libnetclient-ocaml-dev,
 librpc-ocaml-dev,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - core development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use the core
 Ocamlnet libraries in your programs. The following libraries are
 packaged separately: SSL-related libraries (libocamlnet-ssl-ocaml-dev),
 GTK-related libraries (libocamlnet-gtk2-ocaml-dev), nethttpd
 (libnethttpd-ocaml-dev). The netcgi2 Apache connector is also part of
 this package; to run applications built for that connector you will
 need the mod_netcgi_apache Apache module (libapache2-mod-ocamlnet).

Package: libocamlnet-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 libequeue-ocaml,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - core runtime libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains only the shared runtime stub libraries for the
 core Ocamlnet libraries. Stub libraries for SSL-related components are
 available in the libocamlnet-ssl-ocaml-dev package.

Package: libocamlnet-ocaml-bin
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-dev
Description: OCaml application-level Internet libraries - binaries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the binaries ocamlrpcgen (a helper for creating
 RPC stubs) and netplex-admin (generic administration tool for netplex
 systems).

Package: libocamlnet-gtk2-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-doc
Provides:
 libequeue-gtk2-ocaml-dev,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - GTK2 development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use GTK-related
 libraries of Ocamlnet in your programs.

Package: libocamlnet-ssl-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-doc
Description: OCaml application-level Internet libraries - SSL development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use SSL-related
 libraries of Ocamlnet in your programs.

Package: libocamlnet-ssl-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml application-level Internet libraries - SSL runtime libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains only the shared runtime stub libraries for the
 SSL-related libraries of Ocamlnet.

Package: libnethttpd-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: libocamlnet-ocaml-doc
Description: OCaml application-level Internet libraries - HTTP daemon development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use the
 nethttpd library in your programs.

Package: libapache2-mod-netcgi-apache
Architecture: any
Section: httpd
Depends:
 libocamlnet-ocaml-dev (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libapache2-mod-ocamlnet (<< 3.6)
Replaces: libapache2-mod-ocamlnet (<< 3.6)
Provides: libapache2-mod-ocamlnet
# This package contains only an Apache module, dh_ocaml doesn't work on it!
Description: OCaml application-level Internet libraries - netcgi2 Apache2 connector
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the mod_netcgi_apache Apache module. You will

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

PKGNAME = libocamlnet-ocaml-dev
DESTDIR = $(CURDIR)/debian/tmp
export OCAMLFIND_DESTDIR = $(DESTDIR)$(OCAML_STDLIB_DIR)

BUILD_TARGET = all
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
BUILD_TARGET += opt
endif

CFGFLAGS =
CFGFLAGS += -enable-gtk2 -enable-ssl
CFGFLAGS += -with-nethttpd -prefer-netcgi2 -with-rpc-auth-dh
CFGFLAGS += -bindir /usr/bin -datadir /usr/share/ocamlnet
CFGFLAGS += -enable-apache -apache /usr/sbin/apache2 -apxs /usr/bin/apxs2
CFGFLAGS += -enable-pcre -enable-zip -enable-crypto

%:
	dh $@ --with ocaml,apache2

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure $(CFGFLAGS)
ifeq ($(DEB_HOST_ARCH_OS),linux)
# In some build environments (especially cowbuilder and Ubuntu
# autobuilders), many netsys autotests fail even though the feature is
# available (LP: #257524)
	@echo
	@echo "The following netsys features will be forced:"
	@if grep '#undef ' src/netsys/config.h; then \
	  sed -i 's/#undef /#define /' src/netsys/config.h; \
	else \
	  echo "none"; \
	fi
	@echo
endif
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
# No named semaphores on kfreebsd
	sed -i '/netcamlbox/d' debian/libocamlnet-ocaml*.install
	sed -i '/netmulticore/d' debian/libocamlnet-ocaml*.install
endif

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing -X.so.owner -Xmod_netcgi_apache.so

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.ml

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

## ocamlnet 4.0.4

=== Makefile ===
--- 
+++ 
@@ -14,8 +14,12 @@
 # default value if no Makefile.conf exists.
 PKGLIST ?= netstring cgi
 
+.PHONY: build
+build: all
+	if ocamlopt 2>/dev/null; then $(MAKE) opt; fi
+
 .PHONY: all
-all:
+all: tools
 	for pkg in $(PKGLIST); do \
 		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
 		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
@@ -23,7 +27,7 @@
 	done
 
 .PHONY: opt
-opt:
+opt: tools
 	for pkg in $(PKGLIST); do \
 		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
 		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
@@ -41,6 +45,11 @@
 		}; \
 	done
 	cd doc; $(MAKE) doc
+
+.PHONY: tools
+tools:
+	( cd tools/cppo-$(CPPO_VERSION) && $(MAKE) all )
+	( cd tools/unimap_to_ocaml && $(MAKE) all )
 
 
 # The following PHONY rule is important for Cygwin:
@@ -64,6 +73,8 @@
 			( cd $$pkg && $(MAKE) -f Makefile.pre clean); \
 	done
 	if test -f doc/Makefile; then cd doc && $(MAKE) clean; fi
+	( cd tools/cppo-$(CPPO_VERSION) && $(MAKE) clean )
+	( cd tools/unimap_to_ocaml && $(MAKE) clean )
 
 .PHONY: clean-doc
 clean-doc:
@@ -84,3 +95,16 @@
 		test ! -f $$pkg/Makefile || \
 			( cd $$pkg && $(MAKE) -f Makefile.pre distclean); \
 	done
+
+# That one is for oasis
+
+.PHONY: postconf
+postconf:
+	cat setup.save >>setup.data
+
+
+# phony because VERSION may also change
+.PHONY: _oasis
+_oasis: _oasis.in
+	v=`./configure -version`; sed -e 's/@VERSION@/'"$$v/" _oasis.in >_oasis
+	oasis setup

=== examples/pop/Makefile ===
.PHONY: all

APPS=mbox_list

all: $(APPS)

mbox_list: mbox_list.ml
	ocamlfind ocamlc -custom -g -o $@ -package unix,netstring,netclient,nettls-gnutls -linkpkg $<

.PHONY: clean
clean:
	rm -f $(APPS) *.cmi *.cmo

=== src/equeue-gtk1/Makefile ===
TOP_DIR=../..

include ./Makefile.gtk
# Sets GTK_PKG, GTK_VERSION, ARCHIVE, FL_NAME

PKGNAME = $(FL_NAME)
OBJECTS = uq_gtk_helper.cmo uq_gtk.cmo
DOBJECTS = uq_gtk.mli

INCLUDES += $(INC_EQUEUE)
INCLUDES += $(INC_NETSYS)

PP_OPTIONS = -pp "$(CPPO) $(GTK_DEFINES)"

NODEP = @true

include $(TOP_DIR)/Makefile.rules

REQUIRES += $(GTK_PKG)
GTK_DEFINES += -D $(GTK_VERSION)

# Manual deps so we don't need ocamldep:
uq_gtk.cmo: uq_gtk_helper.cmo
uq_gtk.cmo: uq_gtk.cmi
uq_gtk.cmx: uq_gtk_helper.cmx
uq_gtk.cmx: uq_gtk.cmi

=== src/equeue/Makefile ===
TOP_DIR=../..

PKGNAME = equeue
OBJECTS = equeue.cmo unixqueue_util.cmo unixqueue_pollset.cmo \
          unixqueue_select.cmo unixqueue.cmo \
	  uq_resolver.cmo \
          uq_engines.cmo uq_multiplex.cmo uq_transfer.cmo \
          uq_io.cmo uq_lwt.cmo \
	  uq_libevent.cmo uq_mt.cmo uq_client.cmo uq_server.cmo \
          uq_datagram.cmo uq_socks5.cmo uq_engines_compat.cmo
DOBJECTS = equeue.mli unixqueue.mli unixqueue_pollset.mli \
           unixqueue_select.mli \
	   uq_resolver.mli \
           uq_engines.mli uq_multiplex.mli uq_transfer.mli \
           uq_socks5.mli uq_io.mli uq_lwt.mli \
	   uq_libevent.mli uq_mt.mli uq_client.mli uq_server.mli  \
	   uq_datagram.mli uq_engines_compat.mli \
           equeue_intro.txt equeue_howto.txt

INCLUDES += $(INC_NETSYS)
INCLUDES += $(INC_NETSTRING)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netcamlbox/Makefile ===
TOP_DIR=../..

PKGNAME = netcamlbox
OBJECTS =  netcamlbox.cmo
DOBJECTS = netcamlbox.mli

INCLUDES = $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netcgi2-apache/Makefile ===
TOP_DIR=../..

PKGNAME = netcgi2-apache
# Keep the name in sync with the one on handler.c :
BUILD_EXTRA = mod_netcgi_apache.so

INCLUDES += $(INC_NETSTRING) $(INC_NETSYS) $(INC_NETCGI2)
REQUIRES += findlib

OBJECTS = netcgi_apache.cmo netcgi_modtpl.cmo
DOBJECTS = netcgi_apache.mli netcgi_modtpl.mli

ALL_EXTRA = mod_netcgi_apache.so
INSTALL_EXTRA = mod_netcgi_apache.so 500netcgi_apache.info

include $(TOP_DIR)/Makefile.rules

ifeq ($(APACHE_MAJOR),2)
APACHE_LDFLAGS_SHLIB += -lapr-1 -laprutil-1
endif

# mod_netcgi_apache.so: apache.lo handler.lo wrappers.lo netcgi_apache_mod.cmo
# 	$(OCAMLC) -verbose -custom -linkall -o $@ \
# 	  -cc "$(APXS) -c $(filter %.lo,$^)" \
# 	  dynlink.cma unix.cma $(filter-out %.lo,$^) \
# 	  -cclib '$(APACHE_CFLAGS) $(APACHE_LDFLAGS_SHLIB) $(APACHE_OCAMLLIBS)'
# $(patsubst %.o,.libs/%.o,$^) \

# %.o: %.c
# 	$(APACHE_CC) $(APACHE_CFLAGS) -I $(APACHE_OCAMLLIBDIR) -c $<

# -Wl,-bI:$(APACHE_LIBDIR)/httpd.exp
# mod_netcgi_apache.so: netcgi_apache_mod.cmo apache.o handler.o wrappers.o
# 	$(OCAMLC) -o $@ -verbose -linkall -custom \
# 	  -ccopt -Wl,--warn-unresolved-symbols \
# 	  dynlink.cma unix.cma $(patsubst %.o, ./.libs/%.o, $^) \
# 	  -cclib "$(APACHE_CFLAGS) $(APACHE_LDFLAGS_SHLIB) $(APACHE_OCAMLLIBS)"

MOD_OBJECTS := wrappers.o handler.o apache.o netcgi_apache_mod.o

# must be after the `include' for APACHE_MAJOR to be defined
ifeq ($(APACHE_MAJOR),2)
MOD_OBJECTS := $(patsubst %.o,%.lo,$(MOD_OBJECTS))
else
MOD_OBJECTS := $(MOD_OBJECTS)
endif

### Embed Caml code into the C code.
### Requires `caml_startup' instead of `caml_main' in handler.c
### Only works with OCaml >= 3.11 on plafforms where PIC differs from non-PIC
### See http://caml.inria.fr/mantis/view.php?id=3866
mod_netcgi_apache.so: $(MOD_OBJECTS)
	$(APXS) -c -o $@ $^ -L$(APACHE_OCAMLLIBDIR) -Wl,-R,$(APACHE_OCAMLLIBDIR) $(APACHE_OCAMLLIBS)
	test -f .libs/$@ && cp .libs/$@ .

netcgi_apache_mod.lo: netcgi_apache_mod.o
	echo "$@ generated by the rule for $^"
netcgi_apache_mod.o: netcgi_apache_mod.ml
	$(OCAMLC) -verbose -output-obj -linkall -o $@ -cc $(APXS) \
	  dynlink.cma unix.cma findlib.cma $^

%.o: %.c
	$(APXS) -I$(APACHE_OCAMLLIBDIR) -c $<
%.lo: %.c
	$(APXS) -I$(APACHE_OCAMLLIBDIR) -c $<

include depend

=== src/netcgi2-plex/Makefile ===
TOP_DIR=../..

PKGNAME  = netcgi2-plex
OBJECTS  = netcgi_plex.cmo
DOBJECTS = netcgi_plex.mli

INCLUDES += -I ../netcgi2 -I ../netplex -I ../netsys

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netcgi2/Makefile ===
TOP_DIR=../..

PKGNAME  = netcgi
OBJECTS  = netcgi_common.cmo netcgi.cmo \
	netcgi_ajp.cmo netcgi_scgi.cmo netcgi_cgi.cmo \
	netcgi_fcgi.cmo  netcgi_dbi.cmo \
	netcgi1_compat.cmo \
	netcgi_test.cmo

DOBJECTS = netcgi_common.mli netcgi.mli \
	netcgi_ajp.mli netcgi_scgi.mli netcgi_cgi.mli \
	netcgi_fcgi.mli  netcgi_dbi.mli \
	netcgi1_compat.mli \
	netcgi_test.mli \
	netcgi_porting.txt

INCLUDES += $(INC_NETSTRING) $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netclient/Makefile ===
TOP_DIR=../..

PKGNAME = netclient
OBJECTS =  nethttp_client_conncache.cmo nethttp_client.cmo nettelnet_client.cmo \
	   netftp_data_endpoint.cmo netftp_client.cmo \
	   nethttp_fs.cmo netftp_fs.cmo netsmtp.cmo netpop.cmo
DOBJECTS = nethttp_client_conncache.mli nethttp_client.mli nettelnet_client.mli \
	   netftp_data_endpoint.mli netftp_client.mli \
	   nethttp_fs.mli netftp_fs.mli netsmtp.mli netpop.mli \
           netclient_tut.txt

INCLUDES = $(INC_EQUEUE) $(INC_NETSTRING) $(INC_NETSYS)

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netgss-system/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf
# include Makefile.conf

PKGNAME  = netgss-system
OBJECTS  = netgss_bindings.cmo netgss_util.cmo netgss.cmo
COBJECTS = netgss_bindings_stubs.o
DOBJECTS = netgss_bindings.mli netgss.mli

LINK_OPTIONS = $(NETGSS_LINK_OPTIONS)
#LINK_OPTIONS = -lkrb5

CC_OPTIONS = $(NETGSS_CFLAGS)
CC_OPTIONS_FOR_netgss_bindings_stubs.c = -ccopt -Wno-unused-function \
    -ccopt -DNETGSS_VARIANT_"$(NETGSS_VARIANT)"

INCLUDES = $(INC_NETSYS) $(INC_NETSTRING)

include $(TOP_DIR)/Makefile.rules

.PHONY: cobjects
cobjects: $(COBJECTS)

netgss_bindings.ml: done_reconfigure
	@:

netgss_bindings.mli: done_reconfigure
	@:

netgss_bindings_stubs.c: done_reconfigure
	@:

done_reconfigure: gssapi.descr gssapi.c gssapi.ml gssapi.mli
	./reconfigure

include depend

=== src/nethttpd/Makefile ===
--- 
+++ 
@@ -11,10 +11,7 @@
 
 INCLUDES += $(INC_EQUEUE) $(INC_NETSTRING) $(INC_NETCGI2) $(INC_NETPLEX) \
             $(INC_NETSYS)
-PP_OPTIONS = -package "camlp4, camlp4.macro" -syntax "camlp4o"
-
-#PP_OPTIONS_FINDLIB += -ppopt "-DTesting"
-# do this to enable test coverage calculations
+PP_OPTIONS = -pp $(CPPO)
 
 include $(TOP_DIR)/Makefile.rules

=== src/netplex/Makefile ===
TOP_DIR=../..

PKGNAME  = netplex
OBJECTS  = netplex_ctrl_aux.cmo netplex_ctrl_clnt.cmo netplex_ctrl_srv.cmo \
           netplex_util.cmo netplex_encap.cmo \
	   netplex_cenv.cmo netplex_mp.cmo netplex_mt.cmo netplex_log.cmo \
           netplex_container.cmo netplex_sockserv.cmo netplex_workload.cmo \
	   netplex_kit.cmo netplex_controller.cmo \
           netplex_config.cmo netplex_main.cmo rpc_netplex.cmo \
           netplex_semaphore.cmo netplex_sharedvar.cmo netplex_mutex.cmo \
	   netplex_mbox.cmo
DOBJECTS = netplex_types.mli netplex_mp.mli netplex_mt.mli netplex_log.mli \
	   netplex_controller.mli netplex_container.mli \
	   netplex_sockserv.mli netplex_workload.mli netplex_main.mli \
	   netplex_config.mli netplex_kit.mli rpc_netplex.mli \
	   netplex_cenv.mli netplex_semaphore.mli netplex_sharedvar.mli \
	   netplex_mutex.mli netplex_encap.mli netplex_mbox.mli \
	   netplex_intro.txt netplex_advanced.txt netplex_admin.txt

INCLUDES += $(INC_EQUEUE) $(INC_RPC) $(INC_NETSTRING) $(INC_NETSYS)

ALL_EXTRA = netplex-admin$(EXEC_SUFFIX) netplex-packlist 

PACKLIST = netplex-packlist

include $(TOP_DIR)/Makefile.rules

netplex-admin$(EXEC_SUFFIX): netplex.cma netplex_admin.cmo
	$(OCAMLC) -o netplex-admin -custom \
		unix.cma bigarray.cma str.cma \
		netsys_oothr.cma netsys.cma netstring.cma equeue.cma \
		rpc.cma netplex.cma netplex_admin.cmo

netplex-packlist:
	echo $(BINDIR)/netplex-admin >netplex-packlist

include depend

=== debian/changelog ===
ocamlnet (4.0.4-1build3) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:26:54 +0000

ocamlnet (4.0.4-1build2) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 15:53:22 +0000

ocamlnet (4.0.4-1build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 04 Nov 2015 17:15:27 -0600

ocamlnet (4.0.4-1) unstable; urgency=medium

  * New upstream release
    - compiles with OCaml 4.02.3 (Closes: #801550)
    - remove libssl-ocaml-dev and libcryptokit-ocaml-dev from
      Build-Depends; add libgnutls28-dev
    - add patch Fix-compilation-of-Apache-module
  * Bump Standards-Version to 3.9.6

 -- Stéphane Glondu <glondu@debian.org>  Fri, 16 Oct 2015 09:55:18 +0200

ocamlnet (3.7.3-4) unstable; urgency=medium

  * Fix FTBFS: net{camlbox,multicore} are now built on kfreebsd

 -- Stéphane Glondu <glondu@debian.org>  Sat, 23 Aug 2014 15:16:28 +0200

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,10 @@
  libpcre-ocaml-dev (>= 6.0.1-2~),
  liblablgtk2-ocaml-dev (>= 2.12.0-4~),
  libcryptgps-ocaml-dev (>= 0.2.1-7~),
- libssl-ocaml-dev (>= 0.4.3-3~),
  libzip-ocaml-dev,
- libcryptokit-ocaml-dev,
+ libgnutls28-dev,
  apache2-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://projects.camlcity.org/projects/ocamlnet.html
 Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocamlnet.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocamlnet.git

=== debian/rules ===
--- 
+++ 
@@ -15,11 +15,12 @@
 endif
 
 CFGFLAGS =
-CFGFLAGS += -enable-gtk2 -enable-ssl
-CFGFLAGS += -with-nethttpd -prefer-netcgi2 -with-rpc-auth-dh
+CFGFLAGS += -enable-gtk2
+CFGFLAGS += -with-nethttpd -prefer-netcgi2
 CFGFLAGS += -bindir /usr/bin -datadir /usr/share/ocamlnet
 CFGFLAGS += -enable-apache -apache /usr/sbin/apache2 -apxs /usr/bin/apxs2
-CFGFLAGS += -enable-pcre -enable-zip -enable-crypto
+CFGFLAGS += -enable-pcre -enable-zip
+CFGFLAGS += -enable-gnutls
 
 %:
 	dh $@ --with ocaml,apache2
@@ -39,11 +40,6 @@
 	  echo "none"; \
 	fi
 	@echo
-endif
-ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
-# No named semaphores on kfreebsd
-	sed -i '/netcamlbox/d' debian/libocamlnet-ocaml*.install
-	sed -i '/netmulticore/d' debian/libocamlnet-ocaml*.install
 endif
 
 .PHONY: override_dh_auto_build
